<template>
  <v-form
    ref="form"
    @submit.prevent
    @change="$emit('input', form)"
  >
    <v-container>
      <v-row>
        <v-col>
          <date-picker-single-field
            v-model="value.purchaseDate"
            :label="$t('purchaseDate')"
            :min="minDate"
            :max="maxDate"
            :disabled="isLoading"
          />
        </v-col>
        <v-col>
          <categories-select-field
            v-model="value.categoryId"
            :disabled="isLoading"
          />
        </v-col>
        <v-col>
          <company-field
            v-model="value.companyNickname"
            :disabled="isLoading"
          />
        </v-col>
        <v-col>
          <description-field
            v-model="value.description"
            :disabled="isLoading"
          />
        </v-col>
      </v-row>
      <v-row>
        <v-col>
          <payment-methods-select-field
            v-model="value.paymentMethodId"
            :disabled="isLoading"
          />
        </v-col>
        <v-col>
          <payment-statuses-select-field
            v-model="value.paymentStatusId"
            :disabled="isLoading"
          />
        </v-col>
        <v-col>
          <payment-recurrences-select-field
            v-model="value.paymentRecurrenceId"
            :disabled="isLoading"
          />
        </v-col>
        <v-col>
          <number-of-installments-text-field
            v-model="value.numberOfInstallments"
            :min-number-of-installments="MIN_NUMBER_OF_INSTALLMENTS"
            :max-number-of-installments="MAX_NUMBER_OF_INSTALLMENTS"
            :disable-refresh-button="numberOfInstallmentsExceed"
            :disabled="isLoading"
            required
            @onClickRefresh="onClickRefresh"
          />
        </v-col>
      </v-row>
      <v-row>
        <v-col>
          <installments-form
            v-model="value.installments"
            :template="installmentTemplate"
            :disable-add-button="numberOfInstallmentsReached"
            :disabled="isLoading"
            :min-date="minDate"
            :max-date="maxDate"
            :is-edit="isEdit"
            @onClickAdd="updateTheNumberOfInstallmentsAutomatically"
            @onClickRemove="updateTheNumberOfInstallmentsAutomatically"
            @bulkGenerateInstallments="bulkGenerateInstallmentsCallback = $event"
            @reset="$emit('installmentsReset', $event)"
          />
        </v-col>
      </v-row>
    </v-container>
  </v-form>
</template>

<script>
  import InstallmentsForm from './InstallmentsForm'

  const MIN_NUMBER_OF_INSTALLMENTS = 1
  const MAX_NUMBER_OF_INSTALLMENTS = 85

  export default {
    name: 'Form',
    components: {
      InstallmentsForm,
    },
    props: {
      value: {
        type: Object,
        required: true,
      },
      installmentTemplate: {
        type: Object,
        required: true,
      },
      isLoading: {
        type: Boolean,
        required: true,
      },
      isEdit: {
        type: Boolean,
        required: false,
        default: false,
      },
    },
    data () {
      return {
        MIN_NUMBER_OF_INSTALLMENTS,
        MAX_NUMBER_OF_INSTALLMENTS,
        bulkGenerateInstallmentsCallback: null,
      }
    },
    computed: {
      selectedPeriod () {
        return this.$store.getters['periods/getSelectedPeriod']
      },
      minDate () {
        return this.selectedPeriod
          ? this.selectedPeriod.startDate
          : ''
      },
      maxDate () {
        return this.selectedPeriod
          ? this.selectedPeriod.endDate
          : ''
      },
      numberOfInstallmentsExceed () {
        return this.value.numberOfInstallments > this.MAX_NUMBER_OF_INSTALLMENTS
      },
      numberOfInstallmentsReached () {
        return this.value.numberOfInstallments >= this.MAX_NUMBER_OF_INSTALLMENTS
      },
      numberOfInstallments () {
        return this.value.installments.length
      },
    },
    mounted () {
      this.$emit('formRef', this.$refs.form)
    },
    methods: {
      isTheNumberOfInstallmentsValid () {
        const numberOfInstallments = this.value.numberOfInstallments
        return numberOfInstallments >= this.MIN_NUMBER_OF_INSTALLMENTS &&
          numberOfInstallments <= this.MAX_NUMBER_OF_INSTALLMENTS
      },
      onClickRefresh () {
        if (this.isTheNumberOfInstallmentsValid()) {
          this.bulkGenerateInstallmentsCallback(this.value.numberOfInstallments)
        }
      },
      updateTheNumberOfInstallmentsAutomatically () {
        this.value.numberOfInstallments = this.numberOfInstallments
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          purchaseDate: 'Data da compra',
        },
        'en-US': {
          purchaseDate: 'Purchase date',
        },
      },
    },
  }
</script>
